drop database dump3;
create database dump3;
use dump3;
-- create
create table status (
  statusid integer not null primary key,
  status varchar(50) not null unique
);
create table fileinfotype (
  fileinfotypeid integer not null primary key auto_increment,
  fileinfotype varchar(500) not null unique
);
create table fingerprinttype (
  fingerprinttypeid integer not null primary key auto_increment,
  fingerprinttype varchar(100) not null unique,
  INDEX idx_fingerprinttype (fingerprinttype)
);
create table filename (
  filenameid integer not null primary key auto_increment,
  filename varchar(500) not null unique,
  -- filesize long,
  -- filedate long,
  statusid integer references status.statusid on delete cascade,
  INDEX idx_filename (filename)
);
create table fileinfo (
  fileinfotypeid integer references fileinfotype.fileinfotypeid on delete cascade,
  filenameid integer references filename.filenameid on delete cascade,
  fileinfo varchar(500) not null,
  constraint unique index idx_unq_fileinfo (filenameid, fileinfotypeid)
);
create table fingerprint (
  fingerprintid integer not null primary key auto_increment,
  filenameid integer references filename.filenameid on delete cascade,
  fingerprinttypeid integer references fingerprinttype.fingerprinttypeid on delete cascade,
  fingerprint varchar(2000),
  constraint unique index idx_unq_fingerprint (filenameid, fingerprinttypeid)
);
-- use this table instead of notdup
create table duplicate (
  fingerprintid1 integer references fingerprint.fingerprintid on delete cascade,
  fingerprintid2 integer references fingerprint.fingerprintid on delete cascade,
  similarity double not null,
  constraint unique index idx_unq_dup (fingerprintid1, fingerprintid2)
);
-- insert default values
insert into status values (-1,'unknown');
insert into status values (0,'OK');
insert into status values (1,'too short');
insert into status values (2,'signature mismatch');
insert into status values (3,'not readable');
insert into status values (4,'invalid');
insert into status values (5,'corrupt');
insert into status values (6,'empty');
insert into status values (7,'missing');
commit;
